/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.gebietsbaum.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsart;
import de.ivu.elect.business.gebietsbaum.entity.GebietsartUK;

public abstract class AbstractGebietsartDAO extends de.ivu.elect.jee.entity.AbstractDAO<Gebietsart,
        de.ivu.elect.business.gebietsbaum.entity.GebietsartPK
    , GebietsartUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractGebietsartDAO.class);

  public AbstractGebietsartDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.gebietsbaum.entity.GebietsartPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Gebietsart findByPrimaryKey(
        de.ivu.elect.business.gebietsbaum.entity.GebietsartPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Gebietsart findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Gebietsart.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: AllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o WHERE o.mandant=?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.All")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByAll - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByAll - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: AllOrderByPositionNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o WHERE o.mandant=?1 ORDER BY o.position<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByAllOrderByPosition( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.AllOrderByPosition")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByAllOrderByPosition - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByAllOrderByPosition - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAllOrderByPosition(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebieteInWahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o WHERE EXISTS (SELECT e FROM Gebiet e WHERE e.wahl = ?1 and e.gebietsart=o)<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByGebieteInWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.GebieteInWahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebieteInWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByGebieteInWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebieteInWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebieteInWahlVorhandenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT ga FROM Gebietsart ga WHERE EXISTS (SELECT g FROM Gebiet g WHERE g.gebietsart = ga AND g.wahl = ?1)<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByGebieteInWahlVorhanden( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.GebieteInWahlVorhanden")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebieteInWahlVorhanden - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByGebieteInWahlVorhanden - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebieteInWahlVorhanden(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: InMandantVerwendetNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT ga FROM Gebietsart ga WHERE ga.mandant=?1 AND EXISTS (SELECT g FROM Gebiet g WHERE g.gebietsart = ga)<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByInMandantVerwendet( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.InMandantVerwendet")
                              .setParameter(1, mandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByInMandantVerwendet - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByInMandantVerwendet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: NameNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o WHERE o.mandant=?1 AND o.name=?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByName( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull String name) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.mandant.entity.Mandant mandantCheckedAndAttached =  checkAndAttach(mandant, de.ivu.elect.business.mandant.entity.Mandant.class, "mandant"); ;
		  			  String nameCheckedAndAttached =  checkAndAttach(name, String.class, "name"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.Name")
                              .setParameter(1, mandantCheckedAndAttached)
                                        .setParameter(2, nameCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByName - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByName - NonUniqueResultException, Parameter: "
           + ", mandant:'"+mandant+"'"
           + ", name:'"+name+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByName(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartAndDirektwahlgebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o where exists (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o and e.direktwahlgebiet=?2)<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByWahlartAndDirektwahlgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart,  @javax.annotation.Nonnull java.lang.Boolean isDirektwahlgebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  			  java.lang.Boolean isDirektwahlgebietCheckedAndAttached =  isDirektwahlgebiet ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.WahlartAndDirektwahlgebiet")
                              .setParameter(1, wahlartCheckedAndAttached)
                                        .setParameter(2, isDirektwahlgebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlartAndDirektwahlgebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByWahlartAndDirektwahlgebiet - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
           + ", isDirektwahlgebiet:'"+isDirektwahlgebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlartAndDirektwahlgebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartAndListenwahlgebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o where exists (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o and e.listenwahlgebiet=?2)<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByWahlartAndListenwahlgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart,  @javax.annotation.Nonnull java.lang.Boolean isListenwahlgebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  			  java.lang.Boolean isListenwahlgebietCheckedAndAttached =  isListenwahlgebiet ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.WahlartAndListenwahlgebiet")
                              .setParameter(1, wahlartCheckedAndAttached)
                                        .setParameter(2, isListenwahlgebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlartAndListenwahlgebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByWahlartAndListenwahlgebiet - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
           + ", isListenwahlgebiet:'"+isListenwahlgebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlartAndListenwahlgebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartAndWahlgebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o where exists (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o and e.wahlgebiet=?2)<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByWahlartAndWahlgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart,  @javax.annotation.Nonnull java.lang.Boolean isWahlgebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  			  java.lang.Boolean isWahlgebietCheckedAndAttached =  isWahlgebiet ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.WahlartAndWahlgebiet")
                              .setParameter(1, wahlartCheckedAndAttached)
                                        .setParameter(2, isWahlgebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlartAndWahlgebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByWahlartAndWahlgebiet - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
           + ", isWahlgebiet:'"+isWahlgebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlartAndWahlgebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebietsart o where EXISTS (select e from Gebietsarteigenschaft e WHERE e.wahlart = ?1 and e.gebietsart=o)<br>
      * SQL: <br>
      */
     public java.util.List<Gebietsart> findByWahlart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIETSART.Wahlart")
                              .setParameter(1, wahlartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebietsart, findByWahlart - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.gebietsbaum.entity.GebietsartUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.gebietsbaum.entity.GebietsartUK uk,
        de.ivu.elect.business.gebietsbaum.entity.GebietsartPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.gebietsbaum.entity.Gebietsart findByUK(de.ivu.elect.business.gebietsbaum.entity.GebietsartUK uk){

    try {
     return (de.ivu.elect.business.gebietsbaum.entity.Gebietsart) getEntityManager().createNamedQuery("GEBIETSART.UK")
                  .setParameter(1, uk
                .getName ()

              )
             .setParameter(2, uk
                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Gebietsart, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}